#include<phc.h>
#include<stdlib.h>
#include<stdio.h>
#include<phc.h>



/* unregister memory and atexit */
void
xfree (void **p)
{
  free (*p);
  *p = NULL;
  /* shorten link! */
  /* link->p == NULL */
}

/* global */
void
mem_init ()
{
  user_agent = NULL;
  target.key = NULL;

  my.myhost = NULL;

  my.myuserpass = NULL;
  my.header_auth = NULL;

  target.target = NULL;
  target.target_host = NULL;
  target.target_port = NULL;
  target.target_path = NULL;
}

void
xexit (int status)
{
  /* clean global memory */
  /* efficiency is'nt important to exit with little memory cleaned */
  if (user_agent)
    free (user_agent);
  if (target.key)
    free (target.key);
  if (my.myhost)
    free (my.myhost);
  if (my.myuserpass)
    free (my.myuserpass);
  if (my.header_auth)
    free (my.header_auth);
  if (target.target)
    free (target.target);
  if (target.target_host)
    free (target.target_host);
  if (target.target_port)
    free (target.target_port);
  if (target.target_path)
    free (target.target_path);
  exit (status);
}

void *
xmalloc (size_t size)
{
  void *p;
  p = malloc (size);
  if (p == NULL)
    {				/* atexit */
      fprintf (stderr, "%s: Need more memory!\n", progname);
      /* the pointer requesting memory is still NULL */
      xexit (EXIT_FAILURE);	/* atexit will do this similarly */
    }
  else
    {
      /* add to memlist */
      /* p-> link */
      return p;
    }
}


#include <pthread.h>
void *
pxrealloc (void *ptr, size_t size, struct thread_mem *thread_mem)
{
  void *p;
  int ret = EXIT_FAILURE;
  pthread_mutex_lock (&counter_mutex_malloc);
  p = realloc (ptr, size);
  if (p == NULL)
    {
      pthread_mutex_unlock (&counter_mutex_malloc);
      x_pthread_exit ((void *) &ret, thread_mem);
    }
  else
    {
      pthread_mutex_unlock (&counter_mutex_malloc);
      return p;
    }
}
void *
pxmalloc (size_t size, struct thread_mem *thread_mem)
{
  void *p;
  int ret = EXIT_FAILURE;

  pthread_mutex_lock (&counter_mutex_malloc);
  p = malloc (size);
  if (p == NULL)
    {				/* atexit */
      fprintf (stderr, "%s: Need more memory!\n", progname);
      pthread_mutex_unlock (&counter_mutex_malloc);
      x_pthread_exit ((void *) &ret, thread_mem);
      /* exit(EXIT_FAILURE); */
    }
  else
    {				/* add to memlist */
      pthread_mutex_unlock (&counter_mutex_malloc);
      return p;
    }
}
void
thread_mem_init (struct thread_mem *thread_mem)
{
  thread_mem->line = NULL;
  thread_mem->queue.testproxy = NULL;
  thread_mem->request = NULL;
  thread_mem->reply = NULL;
}

void
x_pthread_exit (void *retval, struct thread_mem *thread_mem)
{
  if (thread_mem->line)
    free (thread_mem->line);
  if (thread_mem->queue.testproxy)
    free (thread_mem->queue.testproxy);
  if (thread_mem->request)
    free (thread_mem->request);
  if (thread_mem->reply)
    free (thread_mem->reply);
  pthread_exit (retval);
}

/* unregister memory */
/* now no mutex_lock needed for different var */
void
pxfree (void **p)
{
  free (*p);
  *p = NULL;
  /* shorten link! */
  /* link->p == NULL */
}
